#!/bin/bash
#
# Copyright (C) 2007-2012 Hypertable, Inc.
#
# This file is part of Hypertable.
#
# Hypertable is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 3
# of the License, or any later version.
#
# Hypertable is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Hypertable. If not, see <http://www.gnu.org/licenses/>
#

# set "current" link
pushd . > /dev/null
cd /opt/hypertable/
if [ -h current ]; then
  rm -f current
fi
ln -s 0.9.7.16 current
popd > /dev/null

if [ -d /tmp/hypertable-install ]; then

  # Make backup of new conf files (that are not .cfg or notification-hook.sh)
  rm -f /tmp/hypertable-install/tmp-conf.tgz
  if [ ! -h /opt/hypertable/0.9.7.16/conf ] && [ -d /opt/hypertable/0.9.7.16/conf ]; then
    pushd . > /dev/null
    cd /opt/hypertable/0.9.7.16/conf
    tar czf /tmp/hypertable-install/tmp-conf.tgz --exclude=*.cfg --exclude=notification-hook.sh *
    popd > /dev/null
  fi

  # fixup symlinks
  if [ -e /tmp/hypertable-install/post.sh ]; then
    /tmp/hypertable-install/post.sh
  fi
  
  # Restore backup of new conf files (that are not .cfg or notification-hook.sh)
  if [ -e /tmp/hypertable-install/tmp-conf.tgz ]; then
    pushd . > /dev/null
    cd /opt/hypertable/0.9.7.16/conf/
    tar xzf /tmp/hypertable-install/tmp-conf.tgz
    popd > /dev/null
  fi
  
  # Copy saved config files
  if ls /tmp/hypertable-install/*.cfg > /dev/null 2>&1; then
    cp /tmp/hypertable-install/*.cfg /opt/hypertable/0.9.7.16/conf/
  fi

  # Copy saved notification script
  if [ -e /tmp/hypertable-install/notification-hook.sh ]; then
    cp /tmp/hypertable-install/notification-hook.sh /opt/hypertable/0.9.7.16/conf/
  fi

  # Cleanup
  rm -rf /tmp/hypertable-*
fi
